#include <iomanip>
#include <iostream>
#include <stdlib.h>
#include <conio.h>
#include <ctime>
#include <cmath>

using namespace std;

const int MAX = 3;

class Rectangle { //һ
    public:
        void Set(float _x1, float _y1, float _x2, float _y2) {
            x1=_x1; y1=_y1;
            x2=_x2; y2=_y2;
        }
        void Print() { 
            cout << "A (" << (x1<x2?x1:x2) << ", " << (y1>y2?y1:y2) << ")" << endl;
            cout << "B (" << (x1<x2?x2:x1) << ", " << (y1>y2?y1:y2) << ")" << endl;
            cout << "C (" << (x1<x2?x1:x2) << ", " << (y1>y2?y2:y1) << ")" << endl;
            cout << "D (" << (x1<x2?x2:x1) << ", " << (y1>y2?y2:y1) << ")" << endl << endl;
            cout << "AB = CD = " << getLength() << endl;
            cout << "AC = BD = " << getWidth() << endl << endl;
        }
        float getLength() { return abs(x1-x2); }
        float getWidth() { return abs(y1-y2); }
        float getPerimeter() { return 2*(getLength()+getWidth()); } 
        float getArea() { return getLength()*getWidth(); }
        float getDistance() { 
            float center_x = (x1<x2?(x1+getLength()/2):(x2+getLength()/2));
            float center_y = (y1<y2?(y1+getWidth()/2):(y2+getWidth()/2));
            //cout << "(" << center_x << ", " << center_y << ")" << endl;
            return sqrt(center_x*center_x + center_y*center_y);
        }
        bool isRectangle() {
             if (x1!=x2 && y1!=y2) return true;
             return false;
        }
        float x1, y1, x2,y2;
};

void check(Rectangle &rectangle) {
    system("cls");
    rectangle.Print(); //2εꡢ 
    if (!rectangle.isRectangle()) cout << "It's not a Rectangle!" << endl;
    else {
        cout << "Perimeter = " << rectangle.getPerimeter() << endl; //3㲢εܳ
        cout << "Area = " << rectangle.getArea() << endl << endl; //3㲢ε
        cout << "Distance = " << rectangle.getDistance() << endl; //4ܼԭľ롣
    }
}

int main() {  
    
    srand ( time(NULL) );
    int countOfRect=0;
    do {
        system("cls");
        cout << "countOfRect="; cin >> countOfRect;
    } while ((countOfRect > MAX) || (countOfRect <= 0));
    for (int i=0; i<countOfRect; i++) {
        Rectangle rectangle; //1άռɸΣ
        rectangle.Set((rand() % 20 - 10), (rand() % 20 - 10), (rand() % 20 - 10), (rand() % 20 - 10));
        check(rectangle);
        cout << endl; system("PAUSE");
    }
    
        
// 
    return 0;  
} 
